import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { Component } from 'react';
import getType from './getType';

var reglux = function reglux(store) {
  return function (_ref) {
    var referToState = _ref.referToState,
        hasModel = _ref.hasModel;
    var callbackQueue = [];
    store.subscribe(function () {
      callbackQueue.forEach(function (fn) {
        fn();
      });
    });
    return function (modelSchemas) {
      return function (WrappedComponent) {
        return (
          /*#__PURE__*/
          function (_Component) {
            _inherits(Connect, _Component);

            function Connect(props) {
              var _this;

              _classCallCheck(this, Connect);

              _this = _possibleConstructorReturn(this, _getPrototypeOf(Connect).call(this, props));

              _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "callback", function () {
                var currentState = store.getState();

                if (Object.is(_this.memoizedGlobalState, currentState)) {
                  return;
                }

                _this.memoizedGlobalState = currentState;

                var modelNext = _this.isThereAnyDifference();

                if (_this.shouldComponentUpdateFlag) {
                  _this.setState(modelNext);
                }
              });

              _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "traverse", function (handler) {
                var traverse = function traverse(node) {
                  if (hasModel(node)) {
                    return handler(node);
                  }

                  if (getType(node) === '[object Object]') {
                    var result = {};
                    Object.keys(node).forEach(function (key) {
                      result[key] = traverse(node[key]);
                    });
                    return result;
                  }

                  if (process.env.NODE_ENV === 'development') {
                    // 未知节点的值会返回undefined
                    console.warn("the node \"".concat(node, "\" in schema has not be tracked in the store"));
                  }

                  return undefined;
                };

                return traverse;
              });

              _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "isThereAnyDifference", function () {
                return _this.traverse(function (node) {
                  var result = referToState(node);

                  var cacheResult = _this.cacheStateMap.get(node);

                  if (!Object.is(cacheResult, result)) {
                    _this.shouldComponentUpdateFlag = true; // 将不同的写入

                    _this.cacheStateMap.set(node, result);
                  }

                  return result;
                })(modelSchemas);
              });

              _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "getInitState", function () {
                return _this.traverse(function (node) {
                  var result = referToState(node);

                  _this.cacheStateMap.set(node, result);

                  return result;
                })(modelSchemas);
              });

              _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "confirmModelSchemasIsObject", function () {
                if (!Object.is(getType(modelSchemas), '[object Object]')) {
                  console.trace();
                  throw new Error('the first param of "connect" must be a plain object');
                }
              });

              _this.confirmModelSchemasIsObject();

              _this.shouldComponentUpdateFlag = false;
              _this.memoizedGlobalState = store.getState();
              _this.cacheStateMap = new Map();
              _this.state = _this.getInitState();
              callbackQueue.push(_this.callback);
              return _this;
            }

            _createClass(Connect, [{
              key: "shouldComponentUpdate",
              value: function shouldComponentUpdate(nextProps) {
                return this.shouldComponentUpdateFlag || this.shallowCompareProps(nextProps);
              }
            }, {
              key: "componentDidUpdate",
              value: function componentDidUpdate() {
                this.shouldComponentUpdateFlag = false;
              }
            }, {
              key: "componentWillUnmount",
              value: function componentWillUnmount() {
                var index = callbackQueue.indexOf(this.callback);
                callbackQueue.splice(index, 1);
              }
            }, {
              key: "shallowCompareProps",
              value: function shallowCompareProps(nextProps) {
                var preKeys = Object.keys(this.props);
                var nextKeys = Object.keys(nextProps);

                if (preKeys.length !== nextKeys.length) {
                  return true;
                }

                for (var i = 0; i < preKeys.length; i += 1) {
                  var key = preKeys[i];

                  if (!Object.is(this.props[key], nextProps[key])) {
                    return true;
                  }
                }

                return false;
              }
            }, {
              key: "render",
              value: function render() {
                return React.createElement(WrappedComponent, _extends({}, this.props, this.state));
              }
            }]);

            return Connect;
          }(Component)
        );
      };
    };
  };
};

export default reglux;